// Multi2DecWinDlg.cpp : t@C
//

#include "stdafx.h"
#include "Multi2DecWin.h"
#include "Multi2DecWinDlg.h"

#include "../BonTsEngine/TsPacketParser.h"
#include "../BonTsEngine/TsDescrambler.h"
#include "../BonTsEngine/FileWriter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMulti2DecWinDlg _CAO




CMulti2DecWinDlg::CMulti2DecWinDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMulti2DecWinDlg::IDD, pParent)
	, m_csSrcPath(_T(""))
	, m_csDstPath(_T(""))
	, m_bStopSignal(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMulti2DecWinDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_SRCPATH, m_csSrcPath);
	DDX_Text(pDX, IDC_DSTPATH, m_csDstPath);
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
}

BEGIN_MESSAGE_MAP(CMulti2DecWinDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BROWSESRCPATH, &CMulti2DecWinDlg::OnBnClickedBrowseSrcPath)
	ON_BN_CLICKED(IDC_BROWSEDSTPATH, &CMulti2DecWinDlg::OnBnClickedBrowseDstPath)
	ON_BN_CLICKED(IDC_STARTDECODE, &CMulti2DecWinDlg::OnBnClickedStartDecode)
	ON_BN_CLICKED(IDC_STOPDECODE, &CMulti2DecWinDlg::OnBnClickedStopDecode)
END_MESSAGE_MAP()


// CMulti2DecWinDlg bZ[W nh

BOOL CMulti2DecWinDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CMulti2DecWinDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CMulti2DecWinDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CMulti2DecWinDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMulti2DecWinDlg::OnBnClickedBrowseSrcPath()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CFileDialog Dlg(TRUE, TEXT("ts"), NULL, OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, TEXT("ÍTSt@C (*.ts)|*.ts||"));

	if(Dlg.DoModal() == IDOK){
		m_csSrcPath = Dlg.GetPathName();
		UpdateData(FALSE);
		}
}

void CMulti2DecWinDlg::OnBnClickedBrowseDstPath()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CFileDialog Dlg(FALSE, TEXT("ts"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, TEXT("TSt@C (*.ts)|*.ts||"));

	if(Dlg.DoModal() == IDOK){
		m_csDstPath = Dlg.GetPathName();
		UpdateData(FALSE);
		}
}

void CMulti2DecWinDlg::OnBnClickedStartDecode()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	
	// ʓ|Ȃ̂ŃXbhȂ
	
	// o̓t@C`FbN
	UpdateData(TRUE);
	
	if(m_csSrcPath.IsEmpty() || m_csDstPath.IsEmpty()){
		::AfxMessageBox(TEXT("͂܂͏o̓t@C͂Ă܂B"));
		return;
		}

	if(m_csSrcPath.MakeLower() == m_csDstPath.MakeLower()){
		::AfxMessageBox(TEXT("̓t@Co̓t@Cɂ͎wł܂B"));
		return;
		}

	// fR[_Ot\z
	CTsPacketParser TSPacketParser;
	CTsDescrambler TsDescrambler;
	CFileWriter FileWriter;

	TSPacketParser.SetOutputDecoder(&TsDescrambler);
	TsDescrambler.SetOutputDecoder(&FileWriter);

	// ̓t@CI[v
	CFile SrcFile;

	if(!SrcFile.Open(m_csSrcPath, CFile::modeRead | CFile::shareDenyNone | CFile::osSequentialScan)){
		::AfxMessageBox(TEXT("̓t@C̃I[vɎs܂B"));
		return;
		}

	// o̓t@Cݒ
	FileWriter.OpenFile(m_csDstPath);

	// B-CASJ[hI[v
	if(!TsDescrambler.OpenBcasCard()){
		::AfxMessageBox(TEXT("B-CASJ[h̃I[vɎs܂B"));
		return;
		}

	// i󋵏
	m_Progress.SetPos(0);
	m_Progress.SetRange32(0, (DWORD)(SrcFile.GetLength() >> 10));

	CString csProgText(TEXT("0%%"));
	SetDlgItemText(IDC_PROGTEXT, csProgText);

	// Rg[bN
	GetDlgItem(IDC_BROWSESRCPATH)->EnableWindow(FALSE);
	GetDlgItem(IDC_BROWSEDSTPATH)->EnableWindow(FALSE);
	GetDlgItem(IDC_SRCPATH)->EnableWindow(FALSE);
	GetDlgItem(IDC_DSTPATH)->EnableWindow(FALSE);
	GetDlgItem(IDC_STARTDECODE)->EnableWindow(FALSE);
	GetDlgItem(IDC_STOPDECODE)->EnableWindow(TRUE);

	// fR[h
	DWORD dwReadSize;
	const DWORD dwReadUnit = 1024 * 1024;		// 1MBPʂŃ[h
	BYTE *pReadBuffer = new BYTE[dwReadUnit];	// [hobt@
	
	m_bStopSignal = FALSE;
	
	do{
		// t@C[h
		dwReadSize = SrcFile.Read(pReadBuffer, dwReadUnit);

		// fR[_Otɓ
		if(!TSPacketParser.InputMedia(new CMediaData(pReadBuffer, dwReadSize))){
			m_bStopSignal = TRUE;
			::AfxMessageBox(TEXT("fR[hɃG[܂B"));
			break;
			}

		// i󋵍XV
		csProgText.Format(TEXT("%lu%%"), (SrcFile.GetPosition() * 100) / SrcFile.GetLength());
		SetDlgItemText(IDC_PROGTEXT, csProgText);
		m_Progress.SetPos((DWORD)(SrcFile.GetPosition() >> 10));
		
		// bZ[W(~{^@^)
		MSG Msg;
		while(::PeekMessage(&Msg, NULL, 0, 0, PM_NOREMOVE)){
			AfxGetThread()->PumpMessage();
			}
		}
	while(!m_bStopSignal && (dwReadSize == dwReadUnit));

	delete [] pReadBuffer;

	if(m_bStopSignal){
		::AfxMessageBox(TEXT("fR[h𒆎~܂B"));
		}
	else{
		::AfxMessageBox(TEXT("fR[h܂B"));
		}

	// Rg[bN
	GetDlgItem(IDC_BROWSESRCPATH)->EnableWindow(TRUE);
	GetDlgItem(IDC_BROWSEDSTPATH)->EnableWindow(TRUE);
	GetDlgItem(IDC_SRCPATH)->EnableWindow(TRUE);
	GetDlgItem(IDC_DSTPATH)->EnableWindow(TRUE);
	GetDlgItem(IDC_STARTDECODE)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOPDECODE)->EnableWindow(FALSE);
}

void CMulti2DecWinDlg::OnBnClickedStopDecode()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	m_bStopSignal = TRUE;
}
