// B25Decoder.cpp: CCB25Decoder NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "B25Decoder.h"


//////////////////////////////////////////////////////////////////////
// CX^X\bh
//////////////////////////////////////////////////////////////////////

#pragma warning( disable : 4273 )

extern "C" __declspec(dllexport) IB25Decoder * CreateB25Decoder()
{
	// t@Ng\bh
	return (IB25Decoder *) new CB25Decoder;
}

#pragma warning( default : 4273 )


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CB25Decoder::CB25Decoder()
	: m_OutputBuff(0x100000)	// 1MB̃obt@mۂ
{
	// fR[_Ot\z
	m_TsPacketParser.SetOutputDecoder(&m_TsDescrambler);
	m_TsDescrambler.SetOutputDecoder(&m_MediaGrabber);

	// ςTSpPbg󂯎R[obNo^
	m_MediaGrabber.SetMediaGrabCallback(CB25Decoder::OnPlainTsPacket, (PVOID)this);
}

CB25Decoder::~CB25Decoder()
{

}

const BOOL CB25Decoder::Initialize(DWORD dwRound)
{
	// B-CASJ[hI[vAfR[_OtZbg
	return Reset();
}

void CB25Decoder::Release()
{
	// CX^XJ
	delete this;
}

const BOOL CB25Decoder::Decode(BYTE *pSrcBuf, const DWORD dwSrcSize, BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	if(!pSrcBuf || !pdwDstSize || !ppDstBuf || !pdwDstSize){
		// s
		return FALSE;
		}

	if(!m_TsDescrambler.GetBcasCardID(NULL)){
		// B-CASJ[hI[vĂȂ
		return FALSE;
		}

	// o̓obt@NA
	m_OutputBuff.ClearSize();

	// fBAf[^쐬
	CMediaData *pInputBuff = new CMediaData(pSrcBuf, dwSrcSize);
	
	if(!pInputBuff){
		// s
		return FALSE;
		}

	// fR[_ɓ͂
	if(!m_TsPacketParser.InputMedia(pInputBuff)){
		// fR[_OtŃG[
		pInputBuff->Delete();
		return FALSE;
		}

	// o̓f[^Zbg
	*ppDstBuf = m_OutputBuff.GetData();
	*pdwDstSize = m_OutputBuff.GetSize();

	return TRUE;
}

const BOOL CB25Decoder::Flush(BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	if(!ppDstBuf || !pdwDstSize){
		// s
		return FALSE;
		}

	// o̓f[^Zbg(f[^͎cȂߏɋ)
	*ppDstBuf = NULL;
	*pdwDstSize = 0;

	return TRUE;
}

const BOOL CB25Decoder::Reset(void)
{
	// B-CASJ[hăI[v
	if(!m_TsDescrambler.OpenBcasCard())return FALSE;

	// o̓obt@NA
	m_OutputBuff.ClearSize();

	// fR[_OtZbg
	m_TsPacketParser.Reset();

	return TRUE;
}

void CALLBACK CB25Decoder::OnPlainTsPacket(const CMediaData *pMediaData, const PVOID pParam)
{
	CB25Decoder *pThis = static_cast<CB25Decoder *>(pParam);

	// TSpPbg󂯎R[obN
	pThis->m_OutputBuff.AddData(pMediaData);
}
